#define OLC_PGE_APPLICATION
#include "olcPixelGameEngine.h"
#include "SpriteAnimation.h"

class AnimationExample : public olc::PixelGameEngine
{
public:
	AnimationExample()
	{
		sAppName = "Animation Example";
	}

public:

	SpriteAnimation animation;
	olc::Decal*image;
	bool OnUserCreate() override
	{
		image = new olc::Decal(new olc::Sprite("animation.png"));
		animation.SetParams(1,image->sprite->width,image->sprite->height,4,1,4,1);
		return true;
	}

	bool OnUserUpdate(float fElapsedTime) override
	{
		AnimationData data = animation.GetInfo(fElapsedTime);

		DrawPartialDecal({24,24},{32,32},image,data.sourcePos,data.sourceSize);
		return true;
	}
};


int main()
{
	AnimationExample demo;
	if (demo.Construct(128, 128, 4, 4))
		demo.Start();

	return 0;
}